# DQN
This example trains a DQN agent, from the following paper: [Human-level control through Deep Reinforcement Learning](https://storage.googleapis.com/deepmind-media/dqn/DQNNaturePaper.pdf). 

## Requirements

- atari_py>=0.1.1
- opencv-python

## Running the Example

```
python train_dqn.py [options]
```

### Useful Options
- `--gpu`. Specifies the GPU. If you do not have a GPU on your machine, run the example with the option `--gpu -1`. E.g. `python train_dqn.py --gpu -1`.
- `--env`. Specifies the environment. 
- `--render`. Add this option to render the states in a GUI window.
- `--seed`. This option specifies the random seed used.
- `--outdir` This option specifies the output directory to which the results are written.

To view the full list of options, either view the code or run the example with the `--help` option.

## Results
These results reflect ChainerRL  `v0.4.0`.

| Game        | Score           |
| ------------- |:-------------:|
| Alien | N/A|
| Amidar | N/A|
| Assault | N/A|
| Asterix | N/A|
| Asteroids | N/A|
| Atlantis | N/A|
| Bank Heist | N/A|
| Battlezone | N/A|
| Beamrider | N/A|
| Berzerk | N/A|
| Bowling | N/A|
| Boxing | N/A|
| Carnival | N/A|
| Centipede | N/A|
| Chopper Cmd | N/A|
| Crazy Climber | N/A|
| Demon Attack | N/A|
| Double Dunk | N/A|
| Elevator Action | N/A|
| Enduro | N/A|
| Fishing Derby | N/A|
| Freeway | N/A|
| Frostbite | N/A|
| Gopher | N/A|
| Gravitar | N/A|
| H.E.R.O. | N/A|
| Ice Hockey | N/A|
| James Bond 007 | N/A|
| Journey Escape | N/A|
| Kangaroo | N/A|
| Krull | N/A|
| Kung-Fu Master | N/A|
| Montezumas Rev | N/A|
| Ms. Pac-Man | N/A|
| Name This Game | N/A|
| Phoenix | N/A|
| Pitfall II | N/A|
| Pitfall! | N/A|
| Pooyan | N/A|
| Private Eye | N/A|
| River Raid | N/A|
| Road Runner | N/A|
| Robot Tank | N/A|
| Seaquest | N/A|
| Skiing | N/A|
| Solaris | N/A|
| Space Invaders | N/A|
| Stargunner | N/A|
| Tennis | N/A|
| Time Pilot | N/A|
| Tutankham | N/A|
| Up’n Down | N/A|
| Video Pinball | N/A|
| Zaxxon | N/A|